import gtk
import time

from event import event
from events import events

from docdb import docdb
import cal

from info_editor import info_editor
from recurrence_editor import recurrence_editor

import Calendar

class editor:
	reminder_uses_offset = 0
	def __init__(self, e, end, firstweekday):
		global _; _ = Calendar._
		self.gfx = Calendar.gfx
		self.end = end
		self.e = e
		self.firstweekday = firstweekday
		
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.connect("delete_event", self.delete_event)
		self.window.connect("destroy", self.destroy)
		self.window.set_title(_("gdesklets calendar - Event Editor"))
		self.window.set_border_width(5)
		
		pixbuf = gtk.gdk.pixbuf_new_from_file(self.gfx + "calendar.png")
		self.window.set_icon(pixbuf)
				
		main_vbox = gtk.VBox()
		self.window.add(main_vbox)
		main_vbox.show()
		
		main_frame = gtk.Frame(_("Add Event on ") + time.strftime("%x", time.strptime(self.e.date, "%Y-%m-%d")))
		main_vbox.pack_start(main_frame, gtk.FALSE, gtk.FALSE)
		main_frame.show()


		notebook = gtk.Notebook()
		main_frame.add(notebook)
		notebook.show()


		# page for the information about the event
		info_table = info_editor(self.e, self.firstweekday)
		notebook.append_page(info_table, gtk.Label(_("Generic")))
		info_table.show()



		# page for the recurrence
		rec_table = recurrence_editor(self.e, self.firstweekday)
		notebook.append_page(rec_table, gtk.Label(_("Recurrence")))
		rec_table.show()




		# the ok and close button
		buttons = gtk.HBox()
				
		ok_button = gtk.Button("Ok", gtk.STOCK_OK)
		close_button = gtk.Button("Close", gtk.STOCK_CANCEL)
		buttons.pack_end(close_button, gtk.FALSE, gtk.FALSE, 5)
		buttons.pack_end(ok_button, gtk.FALSE, gtk.FALSE, 5)
		buttons.show_all()
		main_vbox.pack_start(buttons, gtk.FALSE, gtk.FALSE, 3)
			
		close_button.connect("clicked", self.destroy, None)
		ok_button.connect("clicked", self.save_and_quit, None)



		# show the things
		self.window.show()
		
		

		# setting default type
		#self.set_type(event_item, event.EVENT)
		#self.set_reminder_timetype(at_item, 0)
		#self.set_reminder_offset_multi(minutes, 60)
			

	def save_and_quit(self, widget, data=None):
	
		evs = events()
		evs.save_event(self.e)
		self.window.destroy()
		self.end()

	def delete_event(self, widget, event, data=None):
		return gtk.FALSE
		
	def destroy(self, widget, data=None):
		self.window.destroy()
