import gtk
import time

from events import events

import Calendar

class event_viewer:
	def __init__(self, date, x, y):
		global _; _ = Calendar._
		self.gfx = Calendar.gfx
		
		d = "%04d"%date[0] + "-" + "%02d"%date[1] + "-" + "%02d"%date[2]
		locale_date = time.strftime("%x", time.strptime(d, "%Y-%m-%d"))

		ev = events()
		evs = ev.get_events_from_date(date, 1)
		self.appear = 0
		if type(evs) == type([]) and len(evs)>0:
			self.appear = 1
			self.window = gtk.Window(gtk.WINDOW_POPUP)
			self.window.set_border_width(5)

			self.window.move(x, y)
			
			rows = len(evs)
			table = gtk.Table(2 + rows, 3)
			table.set_col_spacings(4)
			self.window.add(table)
			label = gtk.Label(_("Events on ") + locale_date)
			table.attach(label, 0, 3, 0, 1)
			sep = gtk.HSeparator()
			table.attach(sep, 0, 3, 1, 2)
			
			row = 2
			for e in evs:
				if e.has_recurrence == 1:
					pixbuf = gtk.gdk.pixbuf_new_from_file(self.gfx + "recurrency.png")
				else:
					pixbuf = gtk.gdk.pixbuf_new_from_file(self.gfx + "event.png")
				p = pixbuf.scale_simple(18, 18, gtk.gdk.INTERP_BILINEAR)
				image = gtk.Image()
				image.set_from_pixbuf(p)
				table.attach(image, 0, 1, row, row+1)
				if e.full_day == 1:
					label = gtk.Label("<b>" + _("Full Day") + "</b>")
					label.set_use_markup(gtk.TRUE)
				else:
					label = gtk.Label(e.start + " - " + e.end)
				table.attach(label, 1, 2, row, row+1)
				label = gtk.Label(e.summary)
				label.set_alignment(0.0, 0.5)
				table.attach(label, 2, 3, row, row+1)
				row += 1
	
	def show(self):
		if self.appear == 1:
			self.window.show_all()


	def hide(self):
		if self.appear == 1:
			self.window.destroy()
