import time

from docdb import docdb
from event import event

class events:
	def __init__(self, filename = "~/.gdesklets/calendar.xml"):
		self.filename = filename
		
	def new_event(self):
		return event()
	
	def save_event(self, event):
		doc = docdb(self.filename)
		
		doc.add_event(event)

	def get_events_from_date(self, date, sorted=0):
		d = "%04d"%date[0] + "-" + "%02d"%date[1] + "-" + "%02d"%date[2]
		doc = docdb(self.filename)
		evs = doc.get_events_from_date(d)
		if sorted == 1:
			evs.sort(self.sort_events)
		return evs
	
	def get_event_days_from_month(self, m, y):
		doc = docdb(self.filename)
		days = doc.get_event_days_from_month(m, y)
		days.sort()
		return days
			
		
	
	def sort_events(self, ev1, ev2):
		t1 = time.strptime(ev1.date + " " + ev1.start, "%Y-%m-%d %H:%M") 
		t2 = time.strptime(ev1.date + " " + ev2.start, "%Y-%m-%d %H:%M")
		ret = time.mktime(t1) - time.mktime(t2)
		return int(ret)
