import gtk

from helpers import CalendarSelection
from evtypes import evtypes
import cal

import Calendar

class info_editor(gtk.Table):
	def __init__(self, e, firstweekday):
		global _; _ = Calendar._
		
		self.e = e
		self.firstweekday = firstweekday
		
		gtk.Table.__init__(self)
		
		self.set_border_width(6)
		self.set_row_spacings(2)
		self.set_col_spacings(2)
		
		# Adding the type selection
		self.type_label = gtk.Label(_("Type:"))
		self.type_label.show()
		
		self.type_select = gtk.Combo()
		self.type_select.set_value_in_list(gtk.TRUE, gtk.FALSE)
		self.type_select.set_case_sensitive(gtk.TRUE)
		
		evt = evtypes()
		typenames = evt.get_type_names()
		self.type_select.set_popdown_strings(typenames)
		
		#event_item.connect("activate", self.set_type, event.EVENT)
		#reminder_item.connect("activate", self.set_type, event.REMINDER)

		self.type_select.show_all()


		self.date_label = gtk.Label(_("Date:"))		
		self.date_label.show()
		
		self.date_sel = CalendarSelection(self.e.date, self.firstweekday)
		self.date_sel.set_date(self.e.date)
		self.date_sel.show()
		
		self.date_sel.entry.connect("activate", self.set_ev_date)

		self.full_day = gtk.CheckButton(_("Full Day Event"))
		self.full_day.show()
		
		if self.e.full_day == 1:
			self.full_day.set_active(gtk.TRUE)
			
		self.full_day.connect("clicked", self.set_full_day_event)
		
		self.full_day_alignment = gtk.Alignment(1.0, 1.0, 1.0, 1.0)
		self.full_day_alignment.add(self.full_day)
		self.full_day_alignment.show()

		# Createing the start time widgets:
		self.start_time_label = gtk.Label(_("Start:"))
		self.start_time_label.show()
		
		self.start_time = gtk.Combo()
		self.start_time.set_popdown_strings(cal.get_time_list())
		self.start_time.entry.set_text(self.e.start)
		self.start_time.show_all()
		

		self.start_time.entry.connect("changed", self.set_start_time, None)
		self.start_time.entry.connect("focus-out-event", self.evaluate_time, "start")

		# Adding the end time
		
		self.end_time_label = gtk.Label(_("End:"))
		self.end_time_label.show()
		
		self.end_time = gtk.Combo()
		self.end_time.set_popdown_strings(cal.get_time_list())
		self.end_time.entry.set_text(self.e.end)
		self.end_time.show_all()

		self.end_time.entry.connect("changed", self.set_end_time, None)
		self.end_time.entry.connect("focus-out-event", self.evaluate_time, "end")



		
		# Adding summary entry
		self.summary_label = gtk.Label(_("Summary:"))
		self.summary_label.show()

		self.summary = gtk.HBox()
		entry = gtk.Entry(255)
		if self.e.ID != 0:
			entry.set_text(self.e.summary)
		self.summary.pack_start(entry, gtk.FALSE, gtk.FALSE)
		entry.set_size_request(250, -1)
		self.summary.show_all()
		
		entry.connect("changed", self.set_summary, None)
		
		
		# Adding Note textview
		self.note_label = gtk.Label(_("Note:"))
		self.note_label.show()

		self.note = gtk.HBox()
		sw = gtk.ScrolledWindow()
		sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		textview = gtk.TextView()
		textview.set_size_request(250, 50)
		sw.add(textview)
		textview.set_wrap_mode(gtk.WRAP_WORD)
		self.note.pack_start(sw, gtk.FALSE, gtk.FALSE)
		self.note.show_all()

		textbuffer = textview.get_buffer()
		if self.e.ID != 0:
			textbuffer.set_text(self.e.note)
		textbuffer.connect("changed", self.set_note, None)


		# Adding the reminder time
		self.reminder_label = gtk.Label(_("Reminder:"))
		self.reminder_label.show()
		
		self.reminder = gtk.HBox()
		reminder_optionmenu = gtk.OptionMenu()
		reminder_menu = gtk.Menu()
		at_item = gtk.MenuItem(_("At "))
		in_item = gtk.MenuItem(_("In "))
		reminder_menu.append(at_item)
		reminder_menu.append(in_item)
		reminder_optionmenu.set_menu(reminder_menu)
		self.reminder.pack_start(reminder_optionmenu, gtk.FALSE, gtk.FALSE)
		
		at_item.connect("activate", self.set_reminder_timetype, 0) #at
		in_item.connect("activate", self.set_reminder_timetype, 1) #in
		
		adj = gtk.Adjustment(0.0, 0.0, 23.0, 1.0, 5.0, 0.0)
		self.reminder_time1 = gtk.SpinButton(adj, 0, 0)
		self.reminder_time_label = gtk.Label(" : ")
		adj = gtk.Adjustment(0.0, 0.0, 59.0, 1.0, 5.0, 0.0)
		time2 = gtk.SpinButton(adj, 0, 0)
		self.reminder.pack_start(self.reminder_time1, gtk.FALSE, gtk.FALSE)
		self.reminder.pack_start(self.reminder_time_label, gtk.FALSE, gtk.FALSE)
		self.reminder.pack_start(time2, gtk.FALSE, gtk.FALSE)
		
		self.reminder_time1.connect("output", self.set_reminder_time, "h")
		time2.connect("output", self.set_reminder_time, "m")
		
		#reminder in optionmenu
		self.reminder_in = gtk.OptionMenu()
		reminder_in_menu = gtk.Menu()
		minutes = gtk.MenuItem(_("minutes"))
		hours = gtk.MenuItem(_("hours"))
		reminder_in_menu.append(minutes)
		reminder_in_menu.append(hours)
		self.reminder_in.set_menu(reminder_in_menu)
		self.reminder.pack_start(self.reminder_in, gtk.FALSE, gtk.FALSE)
		self.reminder.show_all()
		
		minutes.connect("activate", self.set_reminder_offset_multi, 60)
		hours.connect("activate", self.set_reminder_offset_multi, 3600)



		# Filling the table:
		self.resize(7, 2)
		#self.attach(self.type_label,          0, 1, 0, 1, gtk.FILL, gtk.FILL)
		#self.attach(self.type_select,         1, 2, 0, 1, gtk.FILL, gtk.FILL)
		self.attach(self.date_label,          0, 1, 1, 2, gtk.FILL, gtk.FILL)
		self.attach(self.date_sel,            1, 2, 1, 2, gtk.FILL, gtk.FILL)
		self.attach(self.full_day_alignment, 0, 2, 2, 3, gtk.FILL, gtk.FILL)
		self.attach(self.start_time_label,    0, 1, 3, 4, gtk.FILL, gtk.FILL)
		self.attach(self.start_time,          1, 2, 3, 4, gtk.FILL, gtk.FILL)
		self.attach(self.end_time_label,      0, 1, 4, 5, gtk.FILL, gtk.FILL)
		self.attach(self.end_time,            1, 2, 4, 5, gtk.FILL, gtk.FILL)
		self.attach(self.summary_label,       0, 1, 5, 6, gtk.FILL, gtk.FILL)
		self.attach(self.summary,             1, 2, 5, 6, gtk.FILL, gtk.FILL)
		self.attach(self.note_label,          0, 1, 6, 7, gtk.FILL, gtk.FILL)
		self.attach(self.note,                1, 2, 6, 7, gtk.FILL, gtk.FILL)	
		
		self.run_sensitiveness()

	def run_sensitiveness(self):
		if self.e.full_day == 1:
			self.start_time_label.set_sensitive(gtk.FALSE)
			self.start_time.set_sensitive(gtk.FALSE)
			self.end_time_label.set_sensitive(gtk.FALSE)
			self.end_time.set_sensitive(gtk.FALSE)
		else:
			self.start_time_label.set_sensitive(gtk.TRUE)
			self.start_time.set_sensitive(gtk.TRUE)
			self.end_time_label.set_sensitive(gtk.TRUE)
			self.end_time.set_sensitive(gtk.TRUE)
			
	def set_ev_date(self, entry, data=None):
		self.e.date = self.date_sel.get_date()

	def set_full_day_event(self, widget, data=None):
		self.e.full_day = widget.get_active()
		self.run_sensitiveness()

	def set_start_time(self, widget, data=None):
		self.e.start = widget.get_text()

	def set_end_time(self, widget, data=None):
		self.e.end = widget.get_text()

	def evaluate_time(self, widget, data=None, w=None):
		t = widget.get_text()
		nt = cal.is_time(t)
		if not nt:
			widget.set_text("00:00")
		else:
			widget.set_text(nt)
		if w == "end":
			x = 1 # here we should popup a window, when the 
			      # end time is before the start time


	def set_summary(self, widget, data):
		self.e.summary = widget.get_text()

	def set_note(self, widget, data):
		self.e.note = widget.get_text(widget.get_start_iter(), widget.get_end_iter())
	
	def set_reminder_offset_multi(self, widget, data):
		self.reminder_offset_multi = data

	def set_reminder_timetype(self, widget, ev):
		if ev == 0: # at
			self.reminder_in.hide()
			self.reminder_time1.show()
			self.reminder_time_label.show()
			self.reminder_uses_offset = 0
		elif ev == 1: # in
			self.reminder_in.show()
			self.reminder_time1.hide()
			self.reminder_time_label.hide()
			self.reminder_uses_offset = 1


	def set_reminder_time(self, widget, data):
		if self.reminder_uses_offset == 0:
			t = time.strptime(self.e.start, "%H:%M")
			if data == "h":
				h = int(widget.get_value())
				m = t[4]
			elif data == "m":
				m = int(widget.get_value())
				h = t[3]
			self.e.start = "%02d"%h + ":" + "%02d"%m
		elif self.reminder_uses_offset == 1:
			if data == "m":
				offset = widget.get_value() * self.reminder_offset_multi
				self.e.offset = "%d"%offset


	def set_type(self, widget, evtype):
		self.envtype = evtype
		self.e.set_type(evtype)
		
