from sensor.Sensor import Sensor
from utils.datatypes import *
from utils import i18n

import time
import os
import commands

class LTVMemory(Sensor):

	def __init__(self, interval = "10", snap = "1"):
		global _; _ = i18n.Translator("memory-sensor")
		self.__snap = float(snap)
		Sensor.__init__(self)
		self._set_config_type("update", TYPE_INT, int(interval))
		self._add_thread(self.__command_thread)

	def get_configurator(self):
		configurator = self._new_configurator()
		configurator.set_name(_("Memory monitor"))
		configurator.add_title(_("Display Configuration"))
		configurator.add_spin(_("Update every (ds):"), "update",
					_("Updates the display every x deciseconds"),
					1, 600)
		return configurator
	
	def __command_thread(self):
		while (1):
			if (self._is_stopped()): break
			data = commands.getoutput("cat /proc/meminfo").splitlines()

			total = 0
			free = 0
			buffers = 0
			cached = 0
			
			for line in data :
				fields = line.split()
				if fields[0] == "MemTotal:":
					total = long(fields[1])
				elif fields[0] == "MemFree:":
					free = long(fields[1])
				elif fields[0] == "Buffers:":
					buffers = long(fields[1])
				elif fields[0] == "Cached:":
					cached = long(fields[1])
			pWb = int( 100 * ( total - free ) / total )
			pWOb = int( 100 * ( total - free - buffers - cached) / total )
			pWbSnap = self.__snap * int( pWb / self.__snap )
			pWObSnap = self.__snap * int( pWOb / self.__snap )
			
			data = self._new_output()
			

			data.set("percent", int(pWOb))
			data.set("percentbuff", int(pWb))
			data.set("snap", pWObSnap)
			data.set("snapbuff", pWbSnap)

			data.set("used", str(int((total-free-buffers-cached)/1024)) + "MB" )
			data.set("free", str(int((free+buffers+cached)/1024)) + "MB" )
			data.set("total", str(int(total/1024)) + "MB" )
			self._send_output(data)
			time.sleep(self._get_config("update")*0.1)
def new_sensor(args): return apply(LTVMemory, args)
