"""
filter.py
"""

import types

has_py_wrapper = False
try:
	import textwrap
	has_py_wrapper = True
except:
	pass

class Filter:
	def __init__(self, get_config):
		self._get_config = get_config
		
	def __call__(self, pre):
		work = pre
		
		# crop
		if not self._get_config("crop")==0:
			work = self.__doCrop(work)
			
		# wrap
		if not self._get_config("wrap")==0:
			work = self.__doWrap(work)
		
		if type(work)==types.StringType:
			return [work]
		else:
			return work
		
	def __doCrop(self, l):
		return l[:self._get_config("crop")]
		
	def __doWrap(self, l):
		if has_py_wrapper:
			return textwrap.wrap(l, self._get_config("wrap"), subsequent_indent="...")
		else:
			w = self._get_config("wrap")
			r = []
			while (1):
				if len(l) <= w:
				    r.append(l)
				    break
				else:
				    r.append(l[:w])
				    l = l[w:]
			return r

