"""
ScreenBuffer
"""

EMPTY_TUPLE = ('','','')
INTRO_BUFFER = [
	('#3A3A3A','[multitail]',"               __ __   _  __         _  __"),
	('#2A2A2A','[multitail]',"  __ _  __ __ / // /_ (_)/ /_ ___ _ (_)/ /"),
	('#1A1A1A','[multitail]'," /  ' \/ // // // __// // __// _ `// // / "),
	('#090909','[multitail]',"/_/_/_/\_,_//_/ \__//_/ \__/ \_,_//_//_/  "),
	('#000000','[multitail]',"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
]

class ScreenBuffer:
	def __init__(self, get_config):
		self._get_config = get_config
		self.__buffer = []
		self.__changed = True
	
	def showIntro(self):
		self.__buffer.extend(INTRO_BUFFER)
		self.__changed = True
	
	def __slide(self):
		self.__buffer = self.__buffer[-int(self._get_config("length")):]
			
	def getSize(self):
		return len(self.__buffer)
	
	def isChanged(self):
		return self.__changed
	
	def put(self, color, name, line):
		if self._get_config("length")==0: return
		self.__buffer.append((color, name, line))
		self.__changed = True
		self.__slide()
	
	def get(self, nr):
		if self._get_config("length")==0: return EMPTY_TUPLE
		self.__slide()
		if nr < len(self.__buffer):
			self.__changed = False
			return self.__buffer[nr]
		return EMPTY_TUPLE
	
	def list(self):
		if self._get_config("length")==0: return [EMPTY_TUPLE]
		self.__slide()
		self.__changed = False
		return self.__buffer
